Attribute VB_Name = "basDeclaration"
Option Explicit

'------------------------------------------------------------
' Return codes for PDFSecureRun function.
Public Const PDFSECURE_OK = 0              ' No errors
Public Const PDFSECURE_ERR = 1             ' Unspecified error
Public Const PDFSECURE_ERR_BADKEY = 2      ' Bad license key
Public Const PDFSECURE_ERR_DIRCREATE = 3   ' Failed to create the output file/directory

'------------------------------------------------------------
' 'mode' identifier passed in PageMasterCallback.
' The 'mode' can be used to determine whether a message is an error or
' a progress message.
Public Const PDFSECURE_ERROR = 1        ' Show the error message
Public Const PDFSECURE_MSG = 2          ' Report the message
Public Const PDFSECURE_GETPASS = 3      ' Get the password
Public Const PDFSECURE_OUT_FILENAME = 4 ' Reports the Saved File Names

'------------------------------------------------------------
' API function declarations

'------------------------------------------------------------
' Initialize PDFSecure with registration and license information.
' Although PDFSecureInit is typically called only once (e.g. during the program
' startup), it can also be called multiple times without side effects.
'
' The first parameter is your username, the second parameter is your company name,
' and the last parameter is the license key supplied with your registration information.
'------------------------------------------------------------
Public Declare Function PDFSecureInit Lib "..\..\lib\pdfsecure.dll" _
    (ByVal user_name As String, _
     ByVal company As String, _
     ByVal license_key As String) As Integer

'------------------------------------------------------------
' Execute PDFSecure command string.
'
' PDFSecureRun can be called multiple times to process PDF documents or folders
' with PDF documents. The function is completely thread safe, so it is possible to
' run many PDFSecure threads at the same time.
'
' @param command_str PDFSecure command string. For a detailed explanation of
' all options and syntax, please refer to section 4 in PDFSecure SDK Manual.
'
' @param funct (optional) a pointer to the callback function used to report error
' as well as other messages.
'
' @param user_data (optional) a pointer to custom data that you may want to
' pass to the callback function. NULL if you don't need to pass custom data.
'
' @return error code. A non-zero value indicates that an error was encountered.
'------------------------------------------------------------
Public Declare Function PDFSecureRun Lib "..\..\lib\pdfsecure.dll" _
    (ByVal command_str As String, _
     ByVal callback_funct As Long, _
     ByVal user_data As Long) As Integer


